【CODEFORCES】 F. Ant colony

2024-03-09 07:08
文章标签 ant codeforces colony

本文主要是介绍【CODEFORCES】 F. Ant colony,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

F. Ant colony
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Mole is hungry again. He found one ant colony, consisting of n ants, ordered in a row. Each ant i (1 ≤ i ≤ n) has a strength si.

In order to make his dinner more interesting, Mole organizes a version of «Hunger Games» for the ants. He chooses two numbers l andr (1 ≤ l ≤ r ≤ n) and each pair of ants with indices between l and r (inclusively) will fight. When two ants i and j fight, ant i gets one battle point only if si divides sj (also, ant j gets one battle point only if sj divides si).

After all fights have been finished, Mole makes the ranking. An ant i, with vi battle points obtained, is going to be freed only if vi = r - l, or in other words only if it took a point in every fight it participated. After that, Mole eats the rest of the ants. Note that there can be many ants freed or even none.

In order to choose the best sequence, Mole gives you t segments [li, ri] and asks for each of them how many ants is he going to eat if those ants fight.

Input

The first line contains one integer n (1 ≤ n ≤ 105), the size of the ant colony.

The second line contains n integers s1, s2, ..., sn (1 ≤ si ≤ 109), the strengths of the ants.

The third line contains one integer t (1 ≤ t ≤ 105), the number of test cases.

Each of the next t lines contains two integers li and ri (1 ≤ li ≤ ri ≤ n), describing one query.

Output

Print to the standard output t lines. The i-th line contains number of ants that Mole eats from the segment [li, ri].

Sample test(s)
input
5
1 3 2 4 2
4
1 5
2 5
3 5
4 5
output
4
4
1
1
Note

In the first test battle points for each ant are v = [4, 0, 2, 0, 2], so ant number 1 is freed. Mole eats the ants 2345.

In the second test case battle points are v = [0, 2, 0, 2], so no ant is freed and all of them are eaten by Mole.

In the third test case battle points are v = [2, 0, 2], so ants number 3 and 5 are freed. Mole eats only the ant 4.

In the fourth test case battle points are v = [0, 1], so ant number 5 is freed. Mole eats the ant 4.

题解:这一题其实不难,可以发现如果一个区间内的GCD不等于区间最小值得话,这个区间的所有数都会被吃掉。(因为每个数都不可能被其他的所有数除尽,除非它是这个区间的GCD),而如果这个区间的GCD等于这个区间的最小值的话,这个最小值就会被放掉,然后吃掉剩下的。于是我们就 可以用线段树来维护每个区间的GCD,最小值和最小值个数。查询的时候逐步递进就可以了。

#include <iostream>
#include <cstdio>
#include <cstring>
#include <cstdlib>using namespace std;struct tree
{int mins,l,r,sum,k;
};int s[100005],l,r,n,t,x,mins,sum;
struct tree d[300005];int gcd(int a,int b)
{if (b==0) return a;else return gcd(b,a%b);
}void buildtree(int k,int l,int r)
{d[k].l=l; d[k].r=r;if (l==r){d[k].k=s[l];d[k].mins=s[l];d[k].sum=1;}else{buildtree(k*2,l,(l+r)/2);buildtree(k*2+1,(l+r)/2+1,r);d[k].k=gcd(d[k*2].k,d[k*2+1].k);if (d[k*2].mins==d[k*2+1].mins){d[k].mins=d[k*2].mins;d[k].sum=d[k*2].sum+d[k*2+1].sum;}else if (d[k*2].mins<d[k*2+1].mins){d[k].mins=d[k*2].mins;d[k].sum=d[k*2].sum;}else{d[k].mins=d[k*2+1].mins;d[k].sum=d[k*2+1].sum;}}
}void countk(int k,int l,int r)
{int t=(d[k].l+d[k].r)/2;if (d[k].l==l && d[k].r==r){x=gcd(d[k].k,x);if (mins==d[k].mins) sum+=d[k].sum;else if (mins>d[k].mins){mins=d[k].mins;sum=d[k].sum;}}else if (r<=t) countk(k*2,l,r);else if (l>=t+1) countk(k*2+1,l,r);else{countk(k*2,l,t);countk(k*2+1,t+1,r);}
}int main()
{scanf("%d",&n);for (int i=1;i<=n;i++) scanf("%d",&s[i]);scanf("%d",&t);buildtree(1,1,n);for (int i=1;i<=t;i++){scanf("%d%d",&l,&r);x=s[l]; sum=0;mins=s[l];countk(1,l,r);if (x==mins) printf("%d\n",r-l+1-sum);else printf("%d\n",r-l+1);}return 0;
}


这篇关于【CODEFORCES】 F. Ant colony的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/789897

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

Axure元件库Ant Design中后台原型模板:提升设计与开发效率的利器

企业对于中后台产品的设计与开发需求日益增长。为了提升用户体验和开发效率,设计者和开发者们不断寻求更加高效、统一的解决方案。Ant Design,作为阿里巴巴开源的一套企业级UI设计语言和React组件库,凭借其丰富的组件和统一的设计风格,已成为众多项目的首选。而在Axure中使用Ant Design元件库,更是为中后台产品的原型设计带来了极大的便利。 Ant Design简介 Ant D

Codeforces#295(Div.2)A、B(模拟+BFS)

解题报告链接:点击打开链接 C. 题目链接:点击打开链接 解题思路: 对于给定的字符串,取出现次数最多的字母(可以同时有多个)。由这些字母组成长度为n的字符串,求有多少种组合。最后用数学知识即可。 完整代码: #include <algorithm>#include <iostream>#include <cstring>#include <climits>

Codeforces Round #281 (Div. 2)A(构造+暴力模拟)

题目链接:http://codeforces.com/problemset/problem/493/A 解题思路: 暴力的判断,分三种情况去判断即可。注意如果之前已经被罚下场后,那么在后面的罚下情况不应该算在输出结果内。 完整代码: #include <algorithm>#include <iostream>#include <cstring>#include <co

Codeforces Round #182 (Div. 2)A(水题)

题目链接:http://codeforces.com/contest/302/problem/A 解题思路: 只要通过重新排列使区间内和为0即是1,否则是0. 完整代码: #include <algorithm>#include <iostream>#include <cstring>#include <complex>#include <cstdio>#inc